(function () { 
    if (window.WebViewJavascriptBridge) { return; };
    window.WebViewJavascriptBridge ={};

    console.log("--- NineGameClient init begin---");

    var global = this;
    var ApiBridge = { msgQueue: [], callbackCache: [], callbackId: 0, processingMsg: false };
 
//    global.JSON_org_stringify = global.JSON.stringify;
//    global.JSON.stringify = function(obj) {
//        if (obj.toJSON) {
//            return obj.toJSON();
//        }
//        return global.JSON_org_stringify(obj);
//    };

    ApiBridge.create = function () {
        ApiBridge.bridgeIframe = document.createElement("iframe");
        ApiBridge.bridgeIframe.style.display = 'none';
        document.documentElement.appendChild(ApiBridge.bridgeIframe);
    };
 
    ApiBridge.callNative = function(clz, method, args, callback) {
        if (ApiBridge.bridgeIframe == undefined) {
            ApiBridge.create();
        }
 
        if (callback) {
            var callbackId = ApiBridge.getCallbackId();
            ApiBridge.callbackCache[callbackId] = callback;
            if (args) {
                args.callbackId = callbackId.toString();
            } else {
                args = {"callbackId": callbackId.toString()};
            }
        }

        // push a msg into the queue for native code to process
        ApiBridge.msgQueue.push({"class": clz, "method": method, "args": args});

        // if the messages are being processed on the native side, we don't need to notify
        // the native side again, the given message will be processed in next run.
        // the code on the native side will run a loop to process all pending messages queued on the JS side
        if (!ApiBridge.processingMsg)
            ApiBridge.bridgeIframe.src = "ucnative://go";
    };
 
    ApiBridge.prepareProcessingMessages = function () {
        ApiBridge.processingMsg = true;
    };
 
    // this is called in a loop on the Native side
    ApiBridge.fetchMessages = function () {
        if (ApiBridge.msgQueue.length > 0) {
            var messages = JSON.stringify(ApiBridge.msgQueue);
            ApiBridge.msgQueue.length = 0;
            return messages;
        }
        // no more messages to process, set the flag to false
        ApiBridge.processingMsg = false;
        return null;
    };
 
    ApiBridge.log = function (msg) {
        ApiBridge.callNative("ApiBridge", "JSLog:", {"msg": msg});
    }
 
    ApiBridge.getCallbackId = function () {
        return ApiBridge.callbackId++;
    }
 
    ApiBridge.onCallback = function (callbackId, obj) {
        if (ApiBridge.callbackCache[callbackId]) {
            ApiBridge.callbackCache[callbackId](obj);
//            ApiBridge.callbackCache[callbackId] = undefined; //如果是注册事件的话，不能undefined；
        } 
    }
 

	var NineGameClient = {};
	NineGameClient.Event = {};
//	NineGameClient.Event.LOADED = "loaded";
//	NineGameClient.Event.LOAD_ERROR = "load_error";
//	NineGameClient.Event.LOAD_PROGRESS = "load_progress";
    NineGameClient.addEventListener = function(event, callback)
    {
    ApiBridge.callNative("NineGameClient", "addEventListener:", { "event" : event }, callback);
    }
 
// //sig是android的签名，这里可不用
// NineGameClient.installApp = function(identifier, appName, versionName, versionCode, appUrl, appIconUrl, size, sig)
// {
// 
//    ApiBridge.callNative("NineGameClient", "installApp:",{
//                         "identifier":identifier,
//                         "appName":appName,
//                         "versionName":versionName,
//                         "versionCode":versionCode,
//                         "appUrl":appUrl,
//                         "appIconUrl":appIconUrl,
//                         "size":size,
//                         "sig":sig
//                         });
// }
 
 NineGameClient.startupNativeApp = function(identifier)
 {
 ApiBridge.callNative("NineGameClient","startupNativeApp:",{"identifier":identifier});
 }
 
 NineGameClient.getInstalledAppsAsync = function(callback)
 {
 ApiBridge.callNative("NineGameClient","getInstalledAppsAsync:",{},callback);
 }
 
 NineGameClient.getCurDownloadingTasksAsync = function(callback)
 {
 ApiBridge.callNative("NineGameClient","getCurDownloadingTasksAsync:",{},callback);
 }
 
 //sig是android的签名，这里可不用
 NineGameClient.downloadApp = function (identifier, appName, versionName, versionCode, appUrl, appIconUrl, size, sig, callback)
 {
 ApiBridge.callNative("NineGameClient", "downloadApp:"
                     , {"identifier": identifier, "appName": appName, "versionName": versionName, "versionCode": versionCode, "appUrl": appUrl, "appIconUrl": appIconUrl, "size": size, "sig": sig}, callback);
 }
 
 
 NineGameClient.downloadApp2 = function (jsonObject, callback)
 {
 // I test in the native code the existence of the "jsonObj" property to know whether it is
 // "downloadApp" or "downloadApp2", so I don't need a corresponding `downloadApp2` in the native code
 ApiBridge.callNative("NineGameClient", "downloadApp:", {"jsonObj": JSON.stringify(jsonObject)}, callback);
 };
 
 
 NineGameClient.installApp = function (identifier, versionName)
 {
 ApiBridge.callNative("NineGameClient", "installApp:", {"identifier": identifier, "versionName":versionName});
 }
 
 
 // 返回0表示本地不存在此应用(显示“安装”，启动下载，或者把下载任务添加到pending队列)
 // 返回1表示已安装的包版本>=门户上的包的版本(显示“打开”，点击启动应用)
 // 返回2表示已安装的包版本<门户上的包的版本(显示“升级”，启动下载，或者把下载任务添加到pending队列)
 // 返回3表示正在下载(开始显示“暂停”)
 // 返回4表示下载任务被暂停(显示“继续”，启动下载，或者把下载任务添加到pending队列)
 // 返回5表示本地不存在此应用，但已下载完成(显示“安装”，启动安装程序)
 // 返回6表示已安装的包版本<门户上的包的版本，并且已成功下载最新版本(显示“升级”，启动安装程序)
 NineGameClient.getPackageState = function (identifier, versionName, callback)
 {
 ApiBridge.callNative("NineGameClient", "getPackageState:", {"identifier": identifier, "versionName": versionName}, callback);
 }
 
 // callback = function(pkgName, version, state)
 NineGameClient.registerDownloadStateChangeListener = function (callback)
 {
 NineGameClient.onDownloadStateChange = callback;
 }
 
 
 NineGameClient.stopDownloadTask = function(identifier, versionName)
 {
ApiBridge.callNative("NineGameClient", "stopDownloadTask:", {"identifier": identifier, "versionName": versionName});
 }
 
 NineGameClient.resumeDownloadTask = function(identifier, versionName, callback)
 {
 ApiBridge.callNative("NineGameClient", "resumeDownloadTask:", {"identifier": identifier, "versionName": versionName}, callback);
 }
 
//change image
// ApiBridge.onSetImage = function (elementId, imgPath)
// {
// document.getElementById(elementId).src = imgPath;
// };
 
 
//touch event
 NineGameClient.touchScrollElementIds = [];
 NineGameClient.setTouchScrollElementIds = function (elementIdArray)
 {
 NineGameClient.touchScrollElementIds = elementIdArray;
 };
 
 NineGameClient.addTouchScrollElementId = function(elementId)
 {
 NineGameClient.touchScrollElementIds.push(elementId);
 };
 
 NineGameClient.applyTouchScrollSetting = function ()
 {
 if (NineGameClient.touchScrollElementIds.length > 0) {
 document.addEventListener('touchstart', function(event) {
                           if (NineGameClient.touchScrollElementIds.indexOf(event.target.id) != -1)
                           ApiBridge.callNative("NineGameClient", "setEnableTouchScrollForHomeScreenViewPager:", {"flag": false});
                           }, false);
 document.addEventListener('touchend', function(event) {
                           ApiBridge.callNative("NineGameClient", "setEnableTouchScrollForHomeScreenViewPager:", {"flag": true});
                           }, false);
 }
 };
 
 NineGameClient.setEnableTouchScrollForWebView = function(flag) {
 ApiBridge.callNative("NineGameClient", "setEnableTouchScrollForHomeScreenViewPager:", {"flag": !flag});
 };
 
 NineGameClient.getImgCacheDir = function (callback)
 {
    if (!NineGameClient.ImgCacheDir)
    {
        ApiBridge.callNative("NineGameClient", "getImgCacheDir:", {}, callback);
    }
    else
    {
        callback(NineGameClient.ImgCacheDir);
    }
 };
 
 NineGameClient.getImgCacheDir(function(dir){
                               NineGameClient.ImgCacheDir = dir;
                               });
 
 //change image
 NineGameClient.onImageLoaded = undefined;
 NineGameClient.onSetImage = function (srcSuffix) {
 var obj = document.querySelectorAll('img[src$="'+ srcSuffix +'"]');
 for (var i = 0; i < obj.length; ++i) {
 if (obj[i].getAttribute("firstloadedimage"))
 obj[i].onload = NineGameClient.onImageLoaded;
// obj[i].src = obj[i].src;
 obj[i].src = NineGameClient.ImgCacheDir+srcSuffix;
// ApiBridge.log('>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<'+obj[i].src);
 }
 };
 
 NineGameClient.showMessage = function (msg) {
 ApiBridge.callNative("NineGameClient", "showMessage:", {"msg": msg});
 };
 
 NineGameClient.showSearchDialog = function () {
 ApiBridge.callNative("NineGameClient", "showSearchDialog:");
 };
 
 
 NineGameClient.setSessionString = function (key, value)
 {
    ApiBridge.callNative("NineGameClient", "setSessionString:", {"key": key, "value": value});
 };
 NineGameClient.getSessionString = function (key, callback)
 {
    ApiBridge.callNative("NineGameClient", "getSessionString:", {"key": key}, callback);
 };
 
 NineGameClient.setCurrentDownloadInfo = function (jsonStr) {
    ApiBridge.callNative("NineGameClient", "setCurrentDownloadInfo:", {"info": jsonStr});
 };
 
 
 NineGameClient.setNavigationTitle = function (navigationTitle)
 {
    ApiBridge.callNative("NineGameClient", "setNavigationTitle:", {"navigationTitle": navigationTitle});
 }
 
 NineGameClient.addStat = function(key)
 {
    ApiBridge.callNative("NineGameClient", "addStat:", {"key": key});
 };
 
 NineGameClient.setConfig = function(cfg){
 window.localStorage.setItem("config", JSON.stringify(cfg));
 }
 
 /**********************************************************
  *
  **********************************************************/
 
 var _XMLHttpRequest = function()
 {
    this.id = _XMLHttpRequest.globalId++;
    _XMLHttpRequest.cache[this.id] = this;
 
    this.status = 0;
    this.statusText = '';
    this.readyState = 0;
    this.responseText = '';
    this.headers = {};
    this.onreadystatechange = undefined;
 
    ApiBridge.callNative('XMLHttpRequest', 'create:', {"id": this.id});
 }
 
 _XMLHttpRequest.globalId = 0;
 _XMLHttpRequest.cache = [];
 _XMLHttpRequest.setProperties = function(jsonObj)
 {
    var id = jsonObj.id;
    if (_XMLHttpRequest.cache[id])
    {
        var obj = _XMLHttpRequest.cache[id];
 
        if (jsonObj.hasOwnProperty('status'))
        {
            obj.status = jsonObj.status;
        }
        if (jsonObj.hasOwnProperty('statusText'))
        {
            obj.statusText = jsonObj.statusText;
        }
        if (jsonObj.hasOwnProperty('readyState'))
        {
            obj.readyState = jsonObj.readyState;
        }
        if (jsonObj.hasOwnProperty('responseText'))
        {
            obj.responseText = jsonObj.responseText;
        }
        if (jsonObj.hasOwnProperty('headers'))
        {
            obj.headers = jsonObj.headers;
        }
 
        if (_XMLHttpRequest.cache[id].onreadystatechange)
        {
            _XMLHttpRequest.cache[id].onreadystatechange();
        }
    }
 }
 
 _XMLHttpRequest.prototype.open = function(method, url, async)
 {
    ApiBridge.callNative('XMLHttpRequest', 'open:', {
                         "id" : this.id,
                         "method" : method,
                         "url" : url,
                         "referer" : document.referrer != "" ? document.referrer : null,
                         "useragent" : navigator.userAgent,
                         "cookie" : document.cookie != "" ? document.cookie : null
                         });
 }
 
 _XMLHttpRequest.prototype.send = function(data)
 {
    if (data != null)
    {
        ApiBridge.callNative('XMLHttpRequest', 'send:', { "id" : this.id, "data" : data });
    }
    else
    {
        ApiBridge.callNative('XMLHttpRequest', 'send:', { "id" : this.id });
    }
 }
 _XMLHttpRequest.prototype.overrideMimeType = function(mimetype)
 {
    ApiBridge.callNative('XMLHttpRequest', 'overrideMimeType:', { "id" : this.id, "mimetype" : mimetype });
 }
 _XMLHttpRequest.prototype.abort = function()
 {
    ApiBridge.callNative('XMLHttpRequest', 'abort:', { "id" : this.id });
 }
 _XMLHttpRequest.prototype.setRequestHeader = function(headerName, headerValue)
 {
    ApiBridge.callNative('XMLHttpRequest', 'setRequestHeader:', {
                         "id" : this.id,
                         "headerName" : headerName,
                         "headerValue" : headerValue
                         });
 }
 _XMLHttpRequest.prototype.getAllResponseHeaders = function()
 {
    var strHeaders = '';
    for ( var name in this.headers)
    {
        strHeaders += (name + ": " + this.headers[name] + "\r\n");
    }
    return strHeaders;
 }
 _XMLHttpRequest.prototype.getResponseHeader = function(headerName)
 {
    var strHeaders;
    var upperCaseHeaderName = headerName.toUpperCase();
    for ( var name in this.headers)
    {
        if (upperCaseHeaderName == name.toUpperCase())
        strHeaders = this.headers[name]
    }
    return strHeaders;
 }
 _XMLHttpRequest.deleteObject = function(id)
 {
    if (_XMLHttpRequest.cache[id])
    {
        _XMLHttpRequest.cache[id] = undefined;
    }
 }
 
 /**********************************************************
  *
  **********************************************************/
 
 // expireTime in seconds
 NineGameClient.setCacheString = function (key, value, seconds)
 {
 ApiBridge.callNative("NineGameClient", "setCacheString:", {"key": window.location.pathname + key, "value": value, "seconds": seconds});
 };
 NineGameClient.getCacheString = function (key, callback)
 {
  ApiBridge.callNative("NineGameClient", "getCacheString:", {"key": window.location.pathname + key}, callback);
 };
 
 
 NineGameClient.deleteFirstElement = function(className)
 {
    var all = document.all ? document.all : document.getElementsByTagName('*');
    var elements = new Array();
    for (var e = 0; e < all.length; e++)
    {
        if (all[e].className == className)
        {
            elements[elements.length] = all[e];
            all[e].parentNode.removeChild(all[e]); 
            break;
        }
    }
 }
 
 function getElementsByClassName (className)
 {
    var all = document.all ? document.all : document.getElementsByTagName('*');
    var elements = new Array();
    for (var e = 0; e < all.length; e++)
    {
        if (all[e].className == className)
        {
        elements[elements.length] = all[e];
//        break;
        }
    }
 return elements;
 }

 
	NineGameClient.exit = function() {
        ApiBridge.callNative("NineGameClient", "exit");
	};
    
    var windowOpen = function (url) {
        ApiBridge.callNative("JavascriptAPIInterceptor", "windowOpen:", {"url": url});
    };
 
 
//注册对象 
    global.ApiBridge = ApiBridge;
    global.NineGameClient = NineGameClient;
    global.open = windowOpen;
    global.console.log = ApiBridge.log;
    global.XMLHttpRequest = _XMLHttpRequest;
 

    NineGameClient.register = function(_window) {
        _window.ApiBridge = window.ApiBridge;
        _window.NineGameClient = window.NineGameClient;
        _window.console.log = window.console.log;
        _window.XMLHttpRequest = window.XMLHttpRequest;
        _window.open = window.open;
    };

    console.log("--- NineGameClient init end ---");

})();
